import VueRouter, { type NavigationGuard, type Route, type RouterOptions as RawRouterOptions, type RouteConfig as RouteRecordRaw } from 'vue-router';
export type { NavigationGuard, RouteRecordRaw };
export type { RouteMeta, RouteRecord, RedirectOption as RouteRecordRedirectOption, RawLocation as RouteLocationRaw, } from 'vue-router';
export type RouterScrollBehavior = RawRouterOptions['scrollBehavior'];
export type RouteLocationNormalized = Route;
export type RouteLocationNormalizedLoaded = Route;
export type RouteRecordName = string | symbol;
export interface RouterOptions extends RawRouterOptions {
    routes: RouteRecordRaw[];
    scrollBehavior?: RouterScrollBehavior;
}
export interface Router extends VueRouter {
    isReady: () => Promise<void>;
    /** @deprecated use `currentRoute.matched` instead */
    getMatchedComponents: VueRouter['getMatchedComponents'];
    /** @deprecated use `isReady` instead */
    onReady: VueRouter['onReady'];
}
/** Create Vue Router */
export declare function createRouter(options?: RouterOptions): VueRouter;
/**
 * Get Router instance
 *
 * @deprecated use `vue-router/composables`.
 */
export declare function useRouter(): Router;
/**
 * Get current route instance
 *
 * @deprecated use `vue-router/composables`.
 */
export declare function useRoute(): RouteLocationNormalizedLoaded;
/**
 * Attach leave current route event
 *
 * @deprecated use `vue-router/composables`.
 * @param leaveGuard - Navigation Guard
 * @returns
 */
export declare function onBeforeRouteLeave(leaveGuard: NavigationGuard): void;
/**
 * Attach route before update event
 *
 * @deprecated use `vue-router/composables`.
 * @param updateGuard - Navigation Guard
 * @returns
 */
export declare function onBeforeRouteUpdate(updateGuard: NavigationGuard): void;
//# sourceMappingURL=vue-router.d.ts.map